using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Diagnostics;
using System.Windows.Forms;
 
namespace WordInOutlook2
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("C11A0121-A990-48CD-BF2F-DDAA2F86FD8A"), ProgId("WordInOutlook2.AddinModule"), RunInstaller(true)]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule(System.ComponentModel.IContainer container)
        {
            // This call is required by the Component Designer
            container.Add(this);
            InitializeComponent();
 
            // TODO: Add any initialization after the InitializeComponent call
        }

		private AddinExpress.MSO.ADXOlExplorerCommandBar adxOlExplorerCommandBar1;
		private AddinExpress.MSO.ADXOlInspectorCommandBar adxOlInspectorCommandBar1;
		private AddinExpress.MSO.ADXCommandBarButton adxCommandBarButton1;
		private AddinExpress.MSO.ADXCommandBarButton adxCommandBarButton2;
		private AddinExpress.MSO.ADXWordAppEvents adxWordEvents;
 
        public AddinModule()
        {
            InitializeComponent();
        }
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
			this.components = new System.ComponentModel.Container();
			this.adxOlExplorerCommandBar1 = new AddinExpress.MSO.ADXOlExplorerCommandBar(this.components);
			this.adxCommandBarButton1 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.adxOlInspectorCommandBar1 = new AddinExpress.MSO.ADXOlInspectorCommandBar(this.components);
			this.adxCommandBarButton2 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.adxWordEvents = new AddinExpress.MSO.ADXWordAppEvents(this.components);
			// 
			// adxOlExplorerCommandBar1
			// 
			this.adxOlExplorerCommandBar1.CommandBarName = "Explorer Bar";
			this.adxOlExplorerCommandBar1.CommandBarTag = "56b1569d-a8c8-407f-b911-b8fa962239cf";
			this.adxOlExplorerCommandBar1.Controls.Add(this.adxCommandBarButton1);
			this.adxOlExplorerCommandBar1.Temporary = true;
			this.adxOlExplorerCommandBar1.UpdateCounter = 5;
			// 
			// adxCommandBarButton1
			// 
			this.adxCommandBarButton1.Caption = "Explorer Button";
			this.adxCommandBarButton1.ControlTag = "cb260b71-7fe4-4ec2-b513-45e699c13807";
			this.adxCommandBarButton1.ImageTransparentColor = System.Drawing.Color.Transparent;
			this.adxCommandBarButton1.Temporary = true;
			this.adxCommandBarButton1.UpdateCounter = 2;
			// 
			// adxOlInspectorCommandBar1
			// 
			this.adxOlInspectorCommandBar1.CommandBarName = "Inspector bar";
			this.adxOlInspectorCommandBar1.CommandBarTag = "ab8b0280-146a-4cb4-9d03-774fe6e35399";
			this.adxOlInspectorCommandBar1.Controls.Add(this.adxCommandBarButton2);
			this.adxOlInspectorCommandBar1.Temporary = true;
			this.adxOlInspectorCommandBar1.UpdateCounter = 4;
			// 
			// adxCommandBarButton2
			// 
			this.adxCommandBarButton2.Caption = "Inspector Button";
			this.adxCommandBarButton2.ControlTag = "9cef5a2a-e3a8-46c0-8825-d09a75b2385d";
			this.adxCommandBarButton2.ImageTransparentColor = System.Drawing.Color.Transparent;
			this.adxCommandBarButton2.Temporary = true;
			this.adxCommandBarButton2.UpdateCounter = 2;
			this.adxCommandBarButton2.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.adxCommandBarButton2_Click);
			// 
			// adxWordEvents
			// 
			this.adxWordEvents.WindowActivate += new AddinExpress.MSO.ADXHostWindow_EventHandler(this.adxWordEvents_WindowActivate);
			this.adxWordEvents.Startup += new System.EventHandler(this.adxWordEvents_Startup);
			// 
			// AddinModule
			// 
			this.AddinName = "WordInOutlook2";
			this.SupportedApps = ((AddinExpress.MSO.ADXOfficeHostApp)((AddinExpress.MSO.ADXOfficeHostApp.ohaWord | AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook)));

		}
        #endregion
 
        #region ADX automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion
 
		private void SetCommandBarState()
		{
			if (Process.GetCurrentProcess().MainWindowTitle.IndexOf("Word") == -1)
			{
				object cmb = this.FindCommandBarObj(adxOlInspectorCommandBar1.CommandBarName);
				if (cmb != null)
					(cmb as Microsoft.Office.Core.CommandBar).Visible = true;
			}
			else
			{
				object cmb = this.FindCommandBarObj(adxOlInspectorCommandBar1.CommandBarName);
				if (cmb != null)
					(cmb as Microsoft.Office.Core.CommandBar).Visible = false;
			}
		}

		private void adxWordEvents_WindowActivate(object sender, object hostObj, object window)
		{
			SetCommandBarState();
		}

		private void adxWordEvents_Startup(object sender, System.EventArgs e)
		{
			SetCommandBarState();
		}

		private void adxCommandBarButton2_Click(object sender)
		{
			MessageBox.Show("I am Inspector button!");
		}

	}
}

